/*
 * MIT License
 *
 * Copyright (c) 2020 Mapless AI, Inc.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to
 * deal in the Software without restriction, including without limitation the
 * rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
 * sell copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
 * IN THE SOFTWARE.
 */
#ifndef MAPLESS__SCOPED_TIMER__SCOPED_TIMER_HPP_
#define MAPLESS__SCOPED_TIMER__SCOPED_TIMER_HPP_

#include <chrono>
#include <string>

#include "mapless/timing_statistics/running_statistics.hpp"

namespace mapless {

/** @brief Forward declaration for use in Timing_Statistics. */
class Scoped_Timer;

/**
 * @brief Objects of this class will maintain running statistics of timing
 * information generated by scoped timers instantiated from the 'get_timer'
 * factory method.
 */
class Timing_Statistics : public Running_Statistics {
 public:
  Scoped_Timer get_timer(std::string prefix);
};

/**
 * @brief Scoped timer that measures time between instantiation and destruction.
 *
 * On destruction, the timer will write to the ROS logger how long the object
 * was alive. The message is written to the logger at the INFO verbosity level.
 */
class Scoped_Timer {
 public:
  /**
   * @brief Scoped timer constructors.
   *
   * @param prefix  A string name that prefixes the timing log message.
   * @param ptr     A pointer to a timing statistics object for accumulating
   *                timing stats over time.
   */
  Scoped_Timer();
  explicit Scoped_Timer(std::string prefix);
  Scoped_Timer(std::string prefix, Timing_Statistics* ptr);

  /** @brief On destruction, log timing information. */
  ~Scoped_Timer();

 private:
  std::string prefix;
  Timing_Statistics* ptr;
  std::chrono::steady_clock::time_point t1;
};

}  // namespace mapless

#endif  // MAPLESS__SCOPED_TIMER__SCOPED_TIMER_HPP_
